MKVPROPEDIT(1)

NAZWA
mkvpropedit - Modify properties of existing Matroska(TM) files without a complete remux

SZABLON LINII KOMEND

mkvpropedit [opcje] {źródłowa-nazwapliku} {działania}

OPIS

This program analyses an existing Matroska(TM) file and modifies some of its properties. Then it writes those modifications to the existing file. Among the properties that can be changed are the segment information elements (e.g. the title) and the track headers (e.g. the language code, 'default track' flag or the name).

Opcje:

-l, --list-property-names
    Lists all known and editable property names, their type (string, integer, boolean etc) and a short description. The program exits afterwards. Therefore the source-filename parameter does not have to be supplied.

-p, --parse-mode tryb
    Sets the parse mode. The parameter 'mode' can either be 'fast' (which is also the default) or 'full'. The 'fast' mode does not parse the whole file but uses the meta seek elements for locating the required elements of a source file. In 99% of all cases this is enough. But for files that do not contain meta seek elements or which are damaged the user might have to set the 'full' parse mode. A full scan of a file can take a couple of minutes while a fast scan only takes seconds.

Działania na ścieżkach i właściwościach segmentu:

-e, --edit selektor
    Sets the Matroska(TM) file section (segment information or a certain track's headers) that all following add, set and delete actions operate on. This option can be used multiple times in order to make modifications to more than one element.

    By default mkvpropedit(1) will edit the segment information section.

    See the section about edit selectors for a full description of the syntax.

-a, --add nazwa=wartość
    Dodaje właściwość nazwa z wartością wartość. Właściwość będzie dodana, nawet jeśli taka już istnieje. Zauważ, że większość właściwości jest unikalnych i nie mogą występować więcej niż raz.

-s, --set nazwa=wartość
    Sets all occurrences of the property name to the value value. If no such property exists then it will be added.

-d, --delete nazwa
    Usuwa wszystkie wystąpienia właściwości nazwa. Zauważ, że niektóre właściwości są obowiązkowe i nie mogą być usunięte.

Działania na tagach i rozdziałach:

-t, --tags selektor:nazwa-pliku
    Add or replace tags in the file with the ones from filename or remove them if filename is empty. mkvpropedit(1) reads the same XML tag format that mkvmerge(1) reads as well.

    The selector must be one of the words all, global or track. For all mkvpropedit(1) will replace or remove all tags in a file. With global only global tags will be replaced or removed.

    With track mkvpropedit(1) will replace tags for a specific track. Additionally the tags read from filename will be assigned to the same track. The track is specified in the same way edit selectors are specified (see below), e.g. --tags track:a1:new-audio-tags.xml.

--add-track-statistics-tags
    Calculates statistics for all tracks in a file and adds new statistics tags for them. If the file already contains such tags then they'll be updated.

--delete-track-statistics-tags
    Deletes all existing track statistics tags from a file. If the file doesn't contain track statistics tags then it won't be modified.

-c, --chapters nazwa-pliku
    Add or replace chapters in the file with the ones from filename or remove them if filename is empty. mkvpropedit(1) reads the same XML and simple chapter formats that mkvmerge(1) reads as well.

Działania na załącznikach:

--add-attachment nazwa-pliku
    Dodaje nowy załącznik z innego-pliku.

    If the option --attachment-name has been used prior to this option then its value is used as the new attachment's name. Otherwise it is derived from filename.

    If the option --attachment-mime-type has been used prior to this option then its value is used as the new attachment's MIME type. Otherwise it is auto-detected from the content of filename.

    If the option --attachment-description has been used prior to this option then its value is used as the new attachment's description. Otherwise no description will be set.

    If the option --attachment-uid has been used prior to this option then its value is used as the new attachment's UID. Otherwise a random UID will be generated automatically.

--replace-attachment selektor:nazwa-pliku
    Replaces one or more attachments that match selector with the file filename. If more than one existing attachment matches selector then all of their contents will be replaced by the content of filename.

    The selector can have one of four forms. They're explained below in the section attachment selectors.

    If the option --attachment-name has been used prior to this option then its value is set as the new name for each modified attachment. Otherwise the names aren't changed.

    If the option --attachment-mime-type has been used prior to this option then its value is set as the new MIME type for each modified attachment. Otherwise the MIME types aren't changed.

    If the option --attachment-description has been used prior to this option then its value is set as the new description for each modified attachment. Otherwise the descriptions aren't changed.

    If the option --attachment-uid has been used prior to this option then its value is set as the new UID for each modified attachment. Otherwise the UIDs aren't changed.

--update-attachment selector
    Sets the properties of one or more attachments that match selector. If more than one existing attachment matches selector then all of their properties will be updated.

    The selector can have one of four forms. They're explained below in the section attachment selectors.

    If the option --attachment-name has been used prior to this option then its value is set as the new name for each modified attachment. Otherwise the names aren't changed.

    If the option --attachment-mime-type has been used prior to this option then its value is set as the new MIME type for each modified attachment. Otherwise the MIME types aren't changed.

    If the option --attachment-description has been used prior to this option then its value is set as the new description for each modified attachment. Otherwise the descriptions aren't changed.

    If the option --attachment-uid has been used prior to this option then its value is set as the new UID for each modified attachment. Otherwise the UIDs aren't changed.

--delete-attachment selektor
    Usuwa jeden lub więcej załączników, które pasują do selektor.

    The selector can have one of four forms. They're explained below in the section attachment selectors.

Opcje dla działań na załącznikach:

--attachment-name nazwa
    Sets the name to use for the following --add-attachment or --replace-attachment operation.

--attachment-mime-type typ-mime
    Sets the MIME type to use for the following --add-attachment or --replace-attachment operation.

--attachment-description opis
    Sets the description to use for the following --add-attachment or --replace-attachment operation.

--enable-legacy-font-mime-types
    Enables the use of legacy MIME types for certain types of font attachments. For example, 'application/x-truetype-font' will be used for TrueType fonts instead of 'fonts/ttf'.

    This affects both adding new attachments and replacing existing attachments, but only if the new MIME type isn't specified. Other existing attachments aren't changed.

    The affected MIME types are 'font/sfnt', 'font/ttf' and 'font/collection' which are all mapped to 'application/x-truetype-fonts' and 'font/otf' which is mapped to 'application/vnd.ms-opentype'.

Pozostałe opcje:

--disable-language-ietf
    Normally when the user requests changes to the 'language' track header property, mkvpropedit(1) will apply the same change to the new LanguageIETF track header element in addition to the legacy Language element. If this option is used, the change is only applied to the legacy Language element.

    This option does not affect changes requested via the 'language-ietf' track header property.

--normalize-language-ietf mode
    Enables normalizing all IETF BCP 47 language tags to either their canonical form with mode 'canonical', to their extended language subtags form with mode 'extlang' or turns it off with mode 'off'. By default normalization to the canonical form is applied.

    In the canonical form all subtags for which preferred values exist are replaced by those preferred values. This converts e.g. 'zh-yue-jyutping' to 'yue-jyutping' or 'fr-FX' to 'fr-FR'.

    For the extended language subtags form the canonical form is built first. Afterwards all primary languages for which an extended language subtag exists are replaced by that extended language subtag and its prefix. This converts e.g. 'yue-jyutping' back to 'zh-yue-jyutping' but has no effect on 'fr-FR' as 'fr' is not an extended language subtag.

    This normalization is only applied to elements that are actually changed:

        • When editing track headers only those track language elements that are set via edit specifications are affected. Languages of tracks that aren't edited aren't changed. Editing a track but setting only properties other than the language won't affect the language either.

        • When editing chapters all language elements of all chapter elements are affected as existing chapters are always fully replaced.

        • When editing tags only the language elements of the tags that are actually replaced are affected. For example, when you replace global tags then existing track tags aren't affected.

    The best way to normalize all existing language tags in a file is to remux it with mkvmerge(1) and set its '--normalize-language-ietf' option to the desired mode.

--command-line-charset zestaw-znaków
    Sets the character set to convert strings given on the command line from. It defaults to the character set given by system's current locale.

--output-charset zestaw-znaków
    Sets the character set to which strings are converted that are to be output. It defaults to the character set given by system's current locale.

-r, --redirect-output nazwa-pliku
    Zapisuje wszystkie powiadomienia do pliku nazwa-pliku zamiast do konsoli. Podczas gdy może być to robione łatwo z przekierowaniem wyjścia, są przypadki, gdy ta opcja właśnie jest potrzebna: gdy terminal ponownie interpretuje plik wyjściowy przed zapisaniem do pliku. Uznawany będzie zestaw znaków ustawiony z opcją --output-charset.

--ui-language kod
    Forces the translations for the language code to be used (e.g. 'de_DE' for the German translations). Entering 'list' as the code will cause the program to output a list of available translations.

--abort-on-warnings
    Nakazuje programowi przerwanie po wyemitowaniu pierwszego ostrzeżenia. Kodem wyjścia programu będzie 1.

--debug temat
    Włącz debugowanie dla konkretnej funkcji. Ta opcja jest użyteczna tylko dla deweloperów.

--engage funkcja
    Włącz funkcje eksperymentalne. Listę dostępnych funkcji można uzyskać za pomocą komendy mkvpropedit --engage list. Te funkcje nie są przeznaczone do użytku w normalnych sytuacjach.

--gui-mode
    Turns on GUI mode. In this mode specially-formatted lines may be output that can tell a controlling GUI what's happening. These messages follow the format '#GUI#message'. The message may be followed by key/value pairs as in '#GUI#message#key1=value1#key2=value2...'. Neither the messages nor the keys are ever translated and always output in English.

-v, --verbose
    Be verbose and show all the important Matroska(TM) elements as they're read.

-h, --help
    Pokaż informację o sposobie użycia opcji i wyjdź.

-V, --version
    Pokaż informację o wersji i wyjdź.

@options-file.json
    Reads additional command line arguments from the file options-file. For a full explanation on the supported formats for such files see the section called "Option files" in the mkvmerge(1) man page.

EDIT SELECTORS

The --edit option sets the Matroska(TM) file section (segment information or a certain track's headers) that all following add, set and delete actions operate on. This stays valid until the next --edit option is found. The argument to this option is called the edit selector.

By default mkvpropedit(1) will edit the segment information section.

  Informacje o segmencie

The segment information can be selected with one of these three words: 'info', 'segment_info' or 'segmentinfo'. It contains properties like the segment title or the segment UID.

  Nagłówki ścieżki

Track headers can be selected with a slightly more complex selector. All variations start with 'track:'. The track header properties include elements like the language code, 'default track' flag or the track's name.

track:n
    If the parameter n is a number then the nth track will be selected. The track order is the same that mkvmerge(1)'s --identify option outputs.

    Numerowanie rozpoczyna się od 1.

track:tn
    If the parameter starts with a single character t followed by a n then the nth track of a specific track type will be selected. The track type parameter t must be one of these four characters: 'a' for an audio track, 'b' for a button track, 's' for a subtitle track and 'v' for a video track. The track order is the same that mkvmerge(1)'s --identify option outputs.

    Numerowanie rozpoczyna się od 1.

track:=uid
    If the parameter starts with a '=' followed by a number uid, the track whose track UID element equals the given uid will be selected. Track UIDs can be obtained with mkvinfo(1).

track:@numer
    If the parameter starts with a '@' followed by a number number, the track whose track number element equals this number will be selected. Track numbers can be obtained with mkvinfo(1).

  Uwagi

Due to the nature of the track edit selectors it is possible that several selectors actually match the same track headers. In such cases all actions for those edit selectors will be combined and executed in the order in which they're given on the command line.

SELEKTORY ZAŁĄCZNIKÓW

An attachment selector is used with the two actions --replace-attachment and --delete-attachment. It can have one of the following four forms:

    1. Selection by attachment ID. In this form the selector is simply a number, the attachment's ID as output by mkvmerge(1)'s identification command.

    2. Selection by attachment UID (unique ID). In this form the selector is the equal sign = followed by a number, the attachment's unique ID as output by mkvmerge(1)'s verbose identification command.

    3. Selection by attachment name. In this form the selector is the literal word name: followed by the existing attachment's name. If this selector is used with --replace-attachment then colons within the name to match must be escaped as \c.

    4. Selection by MIME type. In this form the selector is the literal word mime-type: followed by the existing attachment's MIME type. If this selector is used with --replace-attachment then colons within the MIME type to match must be escaped as \c.

LANGUAGE HANDLING

mkvpropedit(1) mostly tries to do the right thing by default. Therefore changes to the language property will cause mkvpropedit(1) to apply the same change to both the new "LanguageIETF" element as well as the old "Language" element similar to how mkvmerge(1) applies the language to both elements. For example, when using mkvpropedit movie.mkv --edit track:2 --set language=zh-TW the "LanguageIETF" element will be set to zh-TW and the old "Language" element to chi.

Additionally there's a new track header property named language-ietf that can be set or removed. Changes to this property only apply to the new "LanguageIETF" track header element. A caveat is that the old "Language" track header element is a mandatory element in Matroska — meaning even if it isn't present in the file it still has an implied value. When the user only sets the language-ietf property but not the language property, mkvpropedit(1) will therefore add the old "Language" element in certain cases & set it to und (meaning "undetermined") as the user didn't specify a value for it.

When reading XML chapter or tag files mkvpropedit(1) works like mkvmerge(1) does.

The creation of the new elements can be disabled completely with the command-line option `--disable-language-ietf` which operates on all three new elements.

You can chose the normalization method applied to extended language sub-tags with the parameter --normalize-language-ietf.

PRZYKŁADY

The following example edits a file called 'movie.mkv'. It sets the segment title and modifies the language code of an audio and a subtitle track. Note that this example can be shortened by leaving out the first --edit option because editing the segment information element is the default for all options found before the first --edit option anyway.

    $ mkvpropedit film.mkv --edit info --set "title=Film" --edit track:a1 --set language=fre --edit track:a2 --set language=pol

The second example removes the 'default track flag' from the first subtitle track and sets it for the second one. Note that mkvpropedit(1), unlike mkvmerge(1), does not set the 'default track flag' of other tracks to '0' if it is set to '1' for a different track automatically.

    $ mkvpropedit film.mkv --edit track:s1 --set flag-default=0 --edit track:s2 --set flag-default=1

Podmiana tagów dla drugiej ścieżki napisów wygląda następująco:

    $ mkvpropedit film.mkv --tags track:s2:nowe-tagi-napisów.xml

Usuwanie wszystkich tagów zakłada pominięcie nazwy pliku:

    $ mkvpropedit film.mkv --tags all:

Podmiana rozdziałów w pliku wygląda następująco:

    $ mkvpropedit film.mkv --chapters nowe-rozdziały.xml

Usuwanie wszystkich rozdziałów zakłada pominięcie nazwy pliku:

    $ mkvpropedit film.mkv --chapters ''

Dodawanie pliku czcionki (Arial.ttf) jako załącznika:

    $ mkvpropedit film.mkv --add-attachment Arial.ttf

Dodawanie pliku czcionki (89719823.ttf) jako załącznika i dostarczanie informacji, że jest to czcionka Arial:

    $ mkvpropedit film.mkv --attachment-name Arial.ttf --attachment-description "Czcionka Arial jako TrueType" --attachment-mime-type application/x-truetype-font --add-attachment 89719823.ttf

Replacing one attached font (Comic.ttf) file with another one (Arial.ttf):

    $ mkvpropedit film.mkv --attachment-name Arial.ttf --attachment-description "Czcionka Arial jako TrueType" --replace-attachment name:Comic.ttf:Arial.ttf

Usuwanie drugiego załącznika, cokolwiek by to nie było:

    $ mkvpropedit film.mkv --delete-attachment 2

Usuwanie wszystkich załączonych czcionek według typu MIME:

    $ mkvpropedit film.mkv --delete-attachment mime-type:application/x-truetype-font

KODY ZAKOŃCZENIA

mkvpropedit(1) exits with one of three exit codes:

    • 0 -- Ten kod zakończenia oznacza, że modyfikacja została zakończona powodzeniem.

    • 1 -- In this case mkvpropedit(1) has output at least one warning, but the modification did continue. A warning is prefixed with the text 'Warning:'. Depending on the issues involved the resulting files might be ok or not. The user is urged to check both the warning and the resulting files.

    • 2 -- This exit code is used after an error occurred. mkvpropedit(1) aborts right after outputting the error message. Error messages range from wrong command line arguments over read/write errors to broken files.

TEXT FILES AND CHARACTER SET CONVERSIONS

Szczegółowe omówienie sposobu, w jaki wszystkie narzędzia w pakiecie MKVToolNix obsługują konwersję zestawu znaków, kodowanie wejściowe/wyjściowe, kodowanie linii komend i kodowanie konsoli, można znaleźć w sekcji o identycznej nazwie na mkvmerge(1) stronie podręcznika.

ZMIENNE ŚRODOWISKOWE

mkvpropedit(1) uses the default variables that determine the system's locale (e.g. LANG and the LC_* family). Additional variables:

MKVPROPEDIT_DEBUG, MKVTOOLNIX_DEBUG i jego skrócona forma MTX_DEBUG
    The content is treated as if it had been passed via the --debug option.

MKVPROPEDIT_ENGAGE, MKVTOOLNIX_ENGAGE i jego skrócona forma MTX_ENGAGE
    The content is treated as if it had been passed via the --engage option.

ZOBACZ TAKŻE

mkvmerge(1), mkvinfo(1), mkvextract(1), mkvtoolnix-gui(1)

STRONA WWW

The latest version can always be found at the MKVToolNix homepage[1].

AUTOR

Moritz Bunkus <moritz@bunkus.org>
    Autor

PRZYPISY

1.  the MKVToolNix homepage
    https://mkvtoolnix.download/